#include <ESP8266HTTPClient.h>
#include <ESP8266WiFi.h>
#include <time.h>

#define PIN_REVENU 16
#define PIN_SORTIE 2

char ssid[] = "Oneplus3";       
char password[] = "jadberro75";

int timezone = 2 * 3600;
int dst =0;

int valRevenu = 0;
int valSortie = 0;
String etat="";
String dateTwitter="";
String heureTwitter="";

void setup() {
  Serial.begin(9600);
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);

  Serial.print("Connecting Wifi: ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }
  
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  IPAddress ip = WiFi.localIP();
  Serial.println(ip);

  configTime(timezone, dst, "pool.ntp.org", "time.nist.gov");

  Serial.println("Attente de l'heure depuis internet");
  while (!time(nullptr)){
    Serial.print("*");
    delay(1000);
  }
  Serial.println("Heure reçue...OK");
}

void loop() {
  
  valRevenu = analogRead(PIN_REVENU);
  valSortie = analogRead(PIN_SORTIE);
  
  time_t now = time(nullptr);
  struct tm* p_tm = localtime(&now);
  String jour = String(p_tm->tm_mday);
  String mois = String(p_tm->tm_mon+1);
  String annee = String(p_tm->tm_year+1900);
  String heure = String(p_tm->tm_hour);
  String minutes = String(p_tm->tm_min);
  String secondes = String(p_tm->tm_sec);
  dateTwitter = jour+"/"+mois+"/"+annee;
  heureTwitter =heure+":"+minutes+":"+secondes;

  if (valRevenu <5){
    etat = "revenu";
    postOnTwitter();
    Serial.println("Je suis "+etat+" à "+heureTwitter+" le "+dateTwitter);

  }
  if (valSortie <5){
    etat = "sorti";
    postOnTwitter();
    Serial.println("Je suis "+etat+" à "+heureTwitter+" le "+dateTwitter);
  }
  
  delay(1000);
  
  }


void postOnTwitter(){
  
  if(WiFi.status()== WL_CONNECTED){   //Vérification de la connection internet
 
   HTTPClient http;    //Declaration du client HTTP
 
   http.begin("http://maker.ifttt.com/trigger/post_tweet/with/key/bWEAdq11jKkXyKRF18unED?value1="+
              dateTwitter+"&value2="+heureTwitter+"&value3="+etat);
   http.addHeader("Content-Type", "text/plain");
 
   int httpCode = http.POST("Hello");   
   String payload = http.getString();
 
   Serial.println(httpCode);
   Serial.println(payload);
 
   http.end();
 
 }else{
 
    Serial.println("Error in WiFi connection");   
 
 }
}
